#include "ghead.h"

INTARRAY* CreateIntArray (SCOUNTER size) {
 INTARRAY* nu;

 nu = (INTARRAY*) g_slice_alloc (sizeof (INTARRAY));
 nu -> max = size;
 nu -> len = 0;
 nu -> data = (SINTEGER*) g_malloc (sizeof (SINTEGER) * size);
 return nu;
}

void DestroyIntArray (INTARRAY* array) {
 g_free (array -> data);
 g_slice_free1 (sizeof (INTARRAY), array);
}

void CopyPtrArray (GPtrArray* dest, GPtrArray* src) {
 SCOUNTER i;

 for (i = 0; i < src -> len; ++ i)
   g_ptr_array_add (dest, g_ptr_array_index (src, i));
}

void ShufflePtrArray (GPtrArray* array) {
 gpointer temp;
 SCOUNTER i;
 SCOUNTER act;

 for (i = 0; i < array -> len; ++ i) {
   act = g_random_int_range (0, array -> len);
   temp = g_ptr_array_index (array, i);
   array -> pdata [i] = array -> pdata [act];
   array -> pdata [act] = temp;
 }
}

void ShuffleSinglePtrArray (GPtrArray* array, SCOUNTER pos) {
 gpointer temp;
 SCOUNTER act;

 if (pos >= array -> len) return;
 act = g_random_int_range (0, array -> len);
 temp = g_ptr_array_index (array, pos);
 array -> pdata [pos] = array -> pdata [act];
 array -> pdata [act] = temp;
}
