#ifndef DIALOGS_HEADER_INCLUDED
#define DIALOGS_HEADER_INCLUDED

#include <gtk/gtk.h>
#include "progbar.h"

typedef struct tagGRIDDIALOG GRIDDIALOG;
struct tagGRIDDIALOG {
 GtkWidget* dialog;
 GtkWidget* sizeEntry;
 GtkWidget* fillEntry;
};

GRIDDIALOG* GridDialog (SREAL size, SINTEGER fill);
void DestroyGridDialog (GRIDDIALOG* grid);

typedef struct tagCOUNTERENTRYDIALOG COUNTERENTRYDIALOG;
struct tagCOUNTERENTRYDIALOG {
 GtkWidget* dialog;
 GtkWidget* entry;
};

COUNTERENTRYDIALOG* CounterEntryDialog (GtkWindow* parent, SCOUNTER count, gchar* name, gchar* caption);
void DestroyCounterEntryDialog (COUNTERENTRYDIALOG* toDel);

typedef struct tagCENTREDIALOG CENTREDIALOG;
struct tagCENTREDIALOG {
 GtkWidget* dialog;
 GtkWidget* latEntry;
 GtkWidget* lonEntry;
};

CENTREDIALOG* CentreDialog ();
void DestroyCentreDialog (CENTREDIALOG* centre);

typedef struct tagMAPLIMITSDIALOG MAPLIMITSDIALOG;
struct tagMAPLIMITSDIALOG {
 GtkWidget* dialog;
 GtkWidget* northEntry;
 GtkWidget* southEntry;
 GtkWidget* eastEntry;
 GtkWidget* westEntry;
};

MAPLIMITSDIALOG* MapLimitsDialog (SREAL n, SREAL s, SREAL e, SREAL w);
void DestroyMapLimitsDialog (MAPLIMITSDIALOG* mapLimits);

typedef struct tagSEARCHDIALOG SEARCHDIALOG;
struct tagSEARCHDIALOG {
 GtkWidget* dialog;
 GtkWidget* iterEntry;
 GtkWidget* equalEntry;
 GtkWidget* pageCheck;
 GtkWidget* keepCheck;
 GtkWidget* allCheck;
};

SEARCHDIALOG* SearchDialog ();
void DestroySearchDialog (SEARCHDIALOG* searchDialog);

typedef struct tagSEARCHPROGDLG SEARCHPROGDLG;
struct tagSEARCHPROGDLG {
 GtkWidget* dialog;
 GtkWidget* treeProgress;
 GtkWidget* iterProgress;
 GtkWidget* stopButton;
 SFLAG progressUp;
 PROGRESSSTRUCT* progressData;
};

SEARCHPROGDLG* SearchProgress (PROGRESSSTRUCT* progress, SFLAG mode);
void DestroyProgressSearchDialog (SEARCHPROGDLG* toDel);

gboolean UpdateSearchProgress (gpointer data);

typedef struct tagPARSINGPROGDLG PARSINGPROGDLG;
struct tagPARSINGPROGDLG {
 GtkWidget* dialog;
 GtkWidget* fileProgress;
 SFLAG progressUp;
 PROGRESSSTRUCT* progressData;
};

PARSINGPROGDLG* ParsingProgress (PROGRESSSTRUCT* progress);
void DestroyParsingProgressDialog (PARSINGPROGDLG* toDel);

gboolean UpdateParsingProgress (gpointer data);

typedef struct tagGEOREFBROWSERDLG GEOREFBROWSERDLG;
struct tagGEOREFBROWSERDLG {
 GtkWidget* dialog;
 GtkWidget* spEntry;
 GtkWidget* nameEntry;
 GtkWidget* latEntry;
 GtkWidget* lonEntry;
 GtkWidget* collecEntry;
 GtkWidget* catalogEntry;
 GtkWidget* urlEntry;
 GtkWidget* referenceEntry;
 GtkWidget* identifierEntry;
 GtkWidget* sampleEntry;
 GtkWidget* nextButton;
 GtkWidget* prevButton;
 GtkWidget* applyButton;
 GtkWidget* delButton;
 GEOREF* actGeo;
};

GEOREFBROWSERDLG* GeoRefBrowser (GEOREF* geo, SFLAG mode);

typedef struct tagNODEDATADIALOG NODEDATADIALOG;
struct tagNODEDATADIALOG {
 GtkWidget* dialog;
 GtkWidget* nameEntry;
 GtkWidget* ageEntry;
};

NODEDATADIALOG* NodeDataDialog (GNode* node, SFLAG mode);
void DestroyNodeDataDialog (NODEDATADIALOG* toDel);

#endif
