#ifndef INPUT_STREAM_FOR_KML_LIKE_FILES_HEADER_INCLUDED
#define INPUT_STREAM_FOR_KML_LIKE_FILES_HEADER_INCLUDED

/* ------ xml file reading ------ */
/* Functions to parse and read a sub-set of XML files, used as input */

#include "ghead.h"
#include "in.h"

#define XML_ERROR           0x0000
#define XML_TOKEN_OPEN      0x0001
#define XML_TOKEN_CLOSE     0x0002
#define XML_TOKEN_COMMENT   0x0004
#define XML_TOKEN_CONTENT   0x0008
#define XML_TOKEN_CDATA     0x0010
#define XML_TOKEN_NOCONTENT 0x0020
#define XML_TOKEN_EMPTY     0x0040
#define XML_WITH_PARAMS     0x0100
#define XML_NO_PARAMS       0x0200
#define XML_AUTO_CLOSE      0x0400

typedef struct tagXMLPARSER XMLPARSER;

/* Reading the XML input */
SFLAG IsXMLFile (INSTREAM* in);
SFLAG ReadToken (INSTREAM* in, GString* dest, SFLAG* tokenState);
SFLAG ReadXMLTokenParam (INSTREAM* in, GString* paramName, GString* paramVal, SFLAG* tokenState);
SFLAG ReadXMLContent (INSTREAM* in, GString* dest, SFLAG* textState);

SFLAG SkipParams (INSTREAM* in);

SFLAG ReadXMLFile (XMLPARSER* xmlParser);

void RemoveFromTokenList (XMLPARSER* xmlParser);
SFLAG IgnoreOpenTag (XMLPARSER* xmlParser);
GString* GetPrevToken (XMLPARSER* xmlParser);

/* Definitions */

struct tagXMLPARSER {
 SFLAG (*OpenTag) ();
 SFLAG (*EndTag) ();
 SFLAG (*OnError) ();

 GString* tempParserString;
 INSTREAM* in;
 gchar* fileHeader;
 GList* tokenStack;
 SFLAG tokenState;
};

#endif
