#ifndef WINDOWED_INTERFACE_HEADER_INCLUDED
#define WINDOWED_INTERFACE_HEADER_INCLUDED

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

/* ------ Windowed interface ------ */
/* General functions and structures used by the graphic user interface. */

#include "biogeo.h"
#include "grid.h"

/* ------ General functions ------ */
GtkWidget* CreateWindow (gchar* name, gint x, gint y, gint sizeX, gint sizeY, GCallback OnDelete, GtkWidget* box);

GtkWidget* AddMenuToBar (GtkWidget* menu, gchar* name, GtkWidget* menuBar);
GtkWidget* CreateMenuItem (GtkWidget* menu, gchar* name, GtkAccelGroup* accelGroup, guint key,
                           GdkModifierType modifier, GCallback func, gpointer data);
GtkWidget* CreateMenuItemCheck (GtkWidget* menu, gchar* name, GtkAccelGroup* accelGroup, guint key,
                                GdkModifierType modifier, GCallback func, gpointer data);
GtkWidget* CreateMenuItemRadio (GtkWidget* menu, gchar* name, GtkAccelGroup* accelGroup, guint key,
                                GdkModifierType modifier, GCallback func, gpointer data, GSList* group);
void CreateMenuSeparator (GtkWidget* menu);

GtkWidget* CreateEntry (gchar* label, GtkBox* box);

GtkFileFilter* CreateFileFilter (gchar* name, gchar* pattern, GtkWidget* fileChooser);

/* ------ Global windows ------ */

/* --- Main window --- */
GtkWidget* mainWindow;
#define GETMAINWIN mainWindow

void StartMainWindow ();
void OnChangeRec ();

/* --- Treee View window --- */
GtkWidget* treeViewWindow;
#define GETTREEWIN treeViewWindow

void StartTreeViewWindow ();
void OpenNewTree ();
void OnChangeTree ();
void SetRecEdition (SFLAG mode);

/* --- Map window --- */
GtkWidget* mapWindow;
#define GETMAPWIN mapWindow

void StartMapWindow ();
void ChangeGeo ();
void ActivateGrid (SFLAG mode);
void SetEdition (SFLAG mode);

void PaintNewGeoRef (GEOREF* geo);

/* ------ Other globals ------ */
GNode* activeNode;

#endif
